SystemOrganization addCategory: #'tODE-Code'!

!TOSystem methodsFor: '*tode-code' stamp: 'dkh 6/3/2011 16:41'!
classHierarchyFor: aClass

	^(({Object. ProtoObject. Class. Behavior. ClassDescription.} includes: aClass)
		ifTrue: [{aClass}, aClass allSuperclasses]
		ifFalse: [aClass withAllSubclasses, aClass allSuperclasses]) asArray! !

!TOSystem methodsFor: '*tode-code' stamp: 'dkh 6/3/2011 16:44'!
defaultMethodCategory

	^SystemOrganizer default! !

!Object methodsFor: '*tode-code' stamp: 'dkh 5/29/2011 10:42'!
renderClassSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-code' stamp: 'dkh 5/29/2011 10:56'!
renderClassTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-code' stamp: 'dkh 5/29/2011 10:41'!
renderMethodSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-code' stamp: 'dkh 5/29/2011 10:35'!
renderMethodTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-code' stamp: 'dkh 5/29/2011 10:41'!
tODEClassSidebarSpec

	^ {(TOTabSpec new)
		id: #classHierarchy;
		rendererClass: TOClassHierarchy;
		receiver: self;
		label: 'subclasses';
		order: 50;
		group: 'development';
		renderSelector: #renderClassSidebarOn:spec:tOdeMain:}! !

!Object methodsFor: '*tode-code' stamp: 'dkh 5/29/2011 10:56'!
tODEClassTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #classBrowser;
		rendererClass: TOClassBrowser;
		receiver: self;
		label: 'class';
		order: 25;
		group: 'development';
		sidebarSpec: self tODEClassSidebarSpec;
		renderSelector: #renderClassTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-code' stamp: 'dkh 5/29/2011 10:40'!
tODEMethodSidebarSpec

	^ {(TOTabSpec new)
		id: #methodCategoryBrowser;
		rendererClass: TOMethodCategoryBrowser;
		receiver: self;
		label: 'method categories';
		order: 50;
		group: 'development';
		renderSelector: #renderMethodSidebarOn:spec:tOdeMain:}! !

!Object methodsFor: '*tode-code' stamp: 'dkh 5/29/2011 10:36'!
tODEMethodTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #methodSourceBrowser;
		rendererClass: TOMethodSourceBrowser;
		receiver: self;
		label: 'method';
		order: 50;
		group: 'development';
		sidebarSpec: self tODEMethodSidebarSpec;
		renderSelector: #renderMethodTabOn:spec:tOdeMain:! !

TOView subclass: #TOCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Code'!

TOCodeBrowser subclass: #TOClassBrowser
	instanceVariableNames: 'classDefinition classTemplate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Code'!

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 19:04'!
classDefinition

	classDefinition ifNil: [ classDefinition := self classDefinitionTemplate: self classTemplate ].
	^ classDefinition! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 18:31'!
classDefinition: anObject
	classDefinition := anObject! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 00:08'!
classTemplate
	"#explorer, #definition, #subclass or #new"
	
	classTemplate ifNil: [ classTemplate := #explorer ].
	^classTemplate ! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 14:41'!
definitionChangedUrl
	^ (self classDefinitionTemplate: self classTemplate) ~= self classDefinition
		ifTrue: [ TOJQueryLibrary urlOf: #redButtonJpg ]
		ifFalse: [ TOJQueryLibrary urlOf: #greenButtonJpg ]! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/30/2011 14:56'!
renderClassDefinitionOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			(html textArea)
				id: id;
				columns: 80;
				rows: self classDefinition lineCount + 1;
				value: self classDefinition;
				callback: [ :value | classDefinition := value ];
				onChange: (html jQuery ajax callback: [ :value | classDefinition := value ] value: (html jQuery id: id) value).
			html break.
			(html submitButton)
				onClick:
						((html jQuery ajax)
								callback: [ :value |  ] value: (html jQuery id: id) value;
								script: [ :s | 
											[ 
											| cl |
											cl := self doit: classDefinition main: main.
											cl ~~ self theClass
												ifTrue: [ self pushit: cl selecting: #classBrowser main: main ].
											main updateCenterSideHistory: s ] on: TOErrorCommand do: [ :ex | main updateCenterSideHistory: s ] ]);
				with: 'Save'.
			html space.
			(html image)
				id: html nextId;
				height: 8;
				width: 8;
				url: self definitionChangedUrl.
			html space.
			(html cancelButton)
				callback: [ :value | classDefinition := self classDefinitionTemplate: self classTemplate ];
				onClick: ((html jQuery id: id) value: (self classDefinitionTemplate: self classTemplate));
				with: 'Cancel' ]
		on: html! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 6/3/2011 15:11'!
renderCommandsOn: html main: main

	self 
		renderCommandButton: #copyClass:script:id: label: 'Copy...' message: 'Copy... not implement' on: html main: main;
		renderCommandButton: #removeClass:script:id: label: 'Remove class...' message: 'Remove class... not implemented' on: html main: main;
		renderCommandButton: #renameClass:script:id: label: 'Rename...' message: 'Rename... not implemented' on: html main: main;
		yourself! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:55'!
renderContentOn: html main: main

	self renderClassHeading: self actualClass on: html main: main.
	html break; break.
	self renderCommandsOn: html main: main.
	html break.
	self renderDefinitionTypeChoiceOn: html main: main.
	html break.
	self classTemplate == #explorer
		ifTrue: [ self renderClassExplorerOn: html main: main ]
		ifFalse: [ self renderClassDefinitionOn: html main: main ]
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:45'!
renderDefinitionTypeChoiceLink: definitionType label: label on: html main: main
	self
		renderButton: [ :s | 
			classTemplate := definitionType.
			classDefinition := nil.
			main updateCenterSideHistory: s ]
		label: label
		on: html.
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:45'!
renderDefinitionTypeChoiceOn: html main: main
	| type |
	type := self classTemplate.
	html break.
	type ~~ #explorer
		ifTrue: [ self renderDefinitionTypeChoiceLink: #explorer label: 'Class explorer' on: html main: main ]
		ifFalse: [ html text: 'Class explorer'; space ].
	type ~~ #definition
		ifTrue: [ self renderDefinitionTypeChoiceLink: #definition label: 'Class definition' on: html main: main ]
		ifFalse: [ html text: 'Class definition'; space ].
	type ~~ #new
		ifTrue: [ self renderDefinitionTypeChoiceLink: #new label: 'New class template' on: html main: main ]
		ifFalse: [ html text: 'New class template'; space ].
	type ~~ #subclass
		ifTrue: [ self renderDefinitionTypeChoiceLink: #subclass label: 'Subclass template' on: html main: main ]
		ifFalse: [ html text: 'Subclass template'; space ].
! !

!TOClassBrowser methodsFor: 'events' stamp: 'dkh 5/26/2011 13:49'!
selectedSuperclassChanged

	super selectedSuperclassChanged.
	classDefinition := nil! !

TOCodeBrowser subclass: #TOClassHierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Code'!

!TOClassHierarchy methodsFor: 'rendering' stamp: 'dkh 6/3/2011 17:01'!
renderContentOn: html main: main
	| order classes indents displayBlock displayString |
	order := SortedCollection
		sortBlock: [ :assoc1 :assoc2 | 
			| result chain1 chain2 max i |
			result := nil.
			chain1 := assoc1 key.
			chain2 := assoc2 key.
			max := chain1 size min: chain2 size.
			i := 1.
			[ result isNil and: [ i <= max ] ]
				whileTrue: [ 
					(chain1 at: i) = (chain2 at: i)
						ifTrue: [ i := i + 1 ]
						ifFalse: [ result := (chain1 at: i) name < (chain2 at: i) name ] ].
			result isNil
				ifTrue: [ chain1 size < chain2 size ]
				ifFalse: [ result ] ].
	classes :=self currentSystem classHierarchyFor: self theClass.
	classes
		do: [ :cl | 
			| supersChain |
			supersChain := cl withAllSuperclasses reversed.
			supersChain removeAllSuchThat: [ :class | (classes includes: class) not ].
			order add: supersChain contents -> cl ].
	indents := IdentityDictionary new.
	order do: [ :assoc | indents at: assoc value put: assoc key size - 1 ].
	classes := classes asArray sorted: [ :a :b | a name <= b name ].
	displayBlock := [ :cl |  ].
	order
		do: [ :assoc | 
			| cl |
			cl := assoc value.
			self
				renderLink: [ :s | 
					self currentSession push: cl selecting: #classBrowser.
					main updateCenterSideHistory: s ]
				with: [ 
					(indents at: cl) * 2 timesRepeat: [ html space ].
					cl == self theClass
						ifTrue: [html strong: cl name asString]
						ifFalse: [html text: cl name asString].
					html break ]
				on: html ]! !

!TOCodeBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:43'!
actualClass

	self object isBehavior
		ifTrue: [ ^self object ].
	^super actualClass! !

!TOCodeBrowser methodsFor: 'rendering' stamp: 'dkh 6/3/2011 15:09'!
renderCommandButton: commandSelector label: label message: message on: html main: main
	| id |
	(html div)
		id: (id := html nextId);
		script:
				((html jQuery new dialog)
						html: message;
						title: 'Information';
						resizable: false;
						modal: true).
	self
		renderButton: [ :s | 
			| aborted |
			aborted := false.
			[ 
			self
				perform: commandSelector
				withArguments:
					{main.
					s.
					id} ] on: TOAbortCommand do: [ :ex | aborted := true ].
			aborted
				ifFalse: [ main updateCenterSideHistory: s ] ]
		label: label
		on: html! !

!TOCodeBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:43'!
theClass

	^self selectedSuperclass ifNil: [ self actualClass ]! !

TOCodeBrowser subclass: #TOMethodBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Code'!

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:39'!
methodSourceBrowser
	^ self frame rendererForCenterTab: #methodSourceBrowser! !

!TOMethodBrowser methodsFor: 'rendering' stamp: 'dkh 5/26/2011 21:01'!
renderSuperclassHeading: aClass on: html main: main
	self sharedClassState
		renderSuperclassHeading: aClass
		renderName: [ :cl | 
			| sel |
			(sel := self selectedMethodSelector) isNil
				ifTrue: [ html strong: cl name ]
				ifFalse: [ 
					(cl includesSelector: sel)
						ifTrue: [ html emphasis: cl name ]
						ifFalse: [ html strong: cl name ] ] ]
		on: html
		main: main! !

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 13:58'!
selectedMethodSelector

	^ self methodSourceBrowser selectedMethodSelector! !

TOMethodBrowser subclass: #TOMethodCategoryBrowser
	instanceVariableNames: 'selectedTab selectedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Code'!

!TOMethodCategoryBrowser methodsFor: 'rendering' stamp: 'dkh 5/27/2011 09:38'!
renderContentOn: html main: main
	(html div)
		id: 'methodCategories';
		script:
				((html jQuery new accordion)
						fillSpace: false;
						autoHeight: false;  
						collapsible: true;
						active: 0
						);
		with: [ 
					html div: [ html anchor: '-- all --' ].
					html div: [ self renderMethodCategory: '-- all --' on: html main: main ].
					self sortedCategories
						do: [ :name | 
							html div: [ html anchor: name ].
							html div: [ self renderMethodCategory: name on: html main: main ] ] ]! !

!TOMethodCategoryBrowser methodsFor: 'rendering' stamp: 'dkh 6/3/2011 16:43'!
renderMethodCategory: cat on: html main: main
	| methods |
	methods := self selectorsForCategory: cat.
	(methods sorted: [ :a :b | a <= b ])
		do: [ :selector | 
			| anchor |
			(anchor := html anchor)
				url: '#';
				onClick:
						(html jQuery ajax
								script: [ :s | 
									selectedSelector := selector.
									self methodSourceBrowser methodReference: (self currentSystem methodReferenceClass class: self theClass selector: selectedSelector).
									main
										updateCenterOn: s;
										updateSidebarOn: s ]);
				yourself.
			self selectedSelector == selector
				ifTrue: [ anchor with: [ :r | r strong: selector asString ] ]
				ifFalse: [ anchor with: selector asString ].
			html break ]! !

!TOMethodCategoryBrowser methodsFor: 'private' stamp: 'dkh 5/26/2011 14:43'!
selectCategory: aMethodCategory
	| cats |
	cats := self sortedCategories.
	1 to: cats size do: [:index |
		(cats at: index) == aMethodCategory ifTrue: [ ^selectedTab := index ]].
	^self selectedTab! !

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 14:00'!
selectedMethodSelector

	^self selectedSelector ! !

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 12:17'!
selectedSelector
	^ selectedSelector! !

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 12:17'!
selectedSelector: anObject
	selectedSelector := anObject! !

!TOMethodCategoryBrowser methodsFor: 'events' stamp: 'dkh 6/3/2011 16:43'!
selectedSuperclassChanged
	super selectedSuperclassChanged.
	self selectedSelector ifNil: [ ^self ].
	self selectCategory: (self theClass whichCategoryIncludesSelector: self selectedSelector).
	self methodSourceBrowser
		methodReference:
			((self theClass includesSelector: self selectedSelector)
				ifTrue: [ self currentSystem methodReferenceClass class: self theClass selector: self selectedSelector ])! !

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 14:40'!
selectedTab

	selectedTab ifNil: [ selectedTab := 0].
	^selectedTab ! !

TOMethodBrowser subclass: #TOMethodSourceBrowser
	instanceVariableNames: 'methodTemplate methodSource methodReference errorFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Code'!

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 05/31/2011 12:31'!
errorFlag

	errorFlag ifNil: [ errorFlag := false ].
	^errorFlag! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 6/3/2011 16:44'!
methodCategory

	self methodReference ifNil: [^self currentSystem defaultMethodCategory ].
	^self methodReference category! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 21:01'!
methodClass

	self methodReference ifNil: [^self theClass ].
	^self methodReference actualClass! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:51'!
methodReference
	^ methodReference! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:51'!
methodReference: anObject
	methodReference := anObject.
	methodSource := nil! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 12:33'!
methodSource
	methodSource ifNil: [ methodSource := self originalSource ].
	^ methodSource! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 6/3/2011 16:17'!
methodSourceBrowser
	^ self! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 14:44'!
methodTemplate
	"#explorer, #editor"
	
	methodTemplate ifNil: [ methodTemplate := #editor ].
	^methodTemplate ! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 12:32'!
originalSource
	^ self methodReference
		ifNil: [ 
			methodSource := 'messageSelectorAndArgumentNames
	"comment stating purpose of message"

	| temporary variable names |
	statements' ]
		ifNotNil: [ methodSource := self methodReference sourceCode ]! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 6/3/2011 15:10'!
renderCommandsOn: html main: main
	| sel |
	((sel := self selectedMethodSelector) notNil and: [self object class == self actualClass])
		ifTrue: [ 
			self
				renderCommandButton: #sendSelectedMessageToSelf:script:id:
				label: 'Send ' , sel printString
				message: '???'
				on: html
				main: main ]! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/30/2011 16:46'!
renderContentOn: html main: main

	self renderClassHeading: self actualClass on: html main: main.
	html break; break.
	self renderCommandsOn: html main: main.
	html break.
	self renderDefinitionTypeChoiceOn: html main: main.
	html break.
	self methodTemplate == #explorer
		ifTrue: [ self renderMethodExplorerOn: html main: main ]
		ifFalse: [ self renderMethodSourceOn: html main: main ]
! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/28/2011 11:50'!
renderDefinitionTypeChoiceLink: definitionType label: label on: html main: main

	self
		renderButton: [ :s | 
			methodTemplate := definitionType.
			methodSource := nil.
			main updateCenterSideHistory: s ]
		label: label
		on: html.
	html space
! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/26/2011 14:46'!
renderDefinitionTypeChoiceOn: html main: main
	| type |
	type := self methodTemplate.
	html break.
	type ~~ #explorer
		ifTrue: [ self renderDefinitionTypeChoiceLink: #explorer label: 'explorer' on: html main: main ]
		ifFalse: [ html text: 'explorer'; space ].
	type ~~ #editor
		ifTrue: [ self renderDefinitionTypeChoiceLink: #editor label: 'editor' on: html main: main ]
		ifFalse: [ html text: 'editor'; space ].
! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:57'!
renderMethodExplorerOn: html main: main
	self renderControl: [ :id :scrpt |  ] on: html! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 05/31/2011 12:45'!
renderMethodSourceOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			 | catId newCat |
newCat := nil.
			html text: 'Category: '.
			(html textInput)
				id: (catId := html nextId);
				value: self methodCategory;
				onEnter:
						((html jQuery ajax)
callback: [:value | newCat := value ] value: (html jQuery id: catId) value;
								script: [ :s | 
											self moveMethodTo: newCat.
newCat := nil.
											main updateCenterSideHistory: s.
											s << ((html jQuery id: catId) value: self methodCategory) ]);
onChange: ((html jQuery ajax) callback: [:value | newCat := value ] value: (html jQuery id: catId) value).
			html break.
			(html textArea)
				id: id;
				columns: (self textAreaColumns: self methodSource);
				rows: (self textAreaRows: self methodSource);
				value: self methodSource;
				callback: [ :value | methodSource := value ];
				onChange: (html jQuery ajax callback: [ :value | methodSource := value ] value: (html jQuery id: id) value).
			html break.
			(html submitButton)
				onClick:
						((html jQuery ajax)
								callback: [ :value | 
											((self accept: value) ~~ nil and: [ newCat notNil ])
												ifTrue: [ "successful accept"
													self moveMethodTo: newCat.
newCat := nil. ].
											(html jQuery id: id) value: self methodSource ]
									value: (html jQuery id: id) value;
								script: [ :s | main updateCenterSideHistory: s ]);
				with: 'Save'.
			html space.
			(html image)
				height: 8;
				width: 8;
				url: self sourceChangedUrl.
			html space.
			(html cancelButton)
					callback: [ :value | methodSource := self originalSource.  ];
					onClick: ((html jQuery id: id) value: self originalSource;
					script: [ :s | errorFlag := false. main updateCenterSideHistory: s ]);
				with: 'Cancel' ]
		on: html! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 13:59'!
selectedMethodSelector

	self methodReference ifNil: [ ^nil ].
	^self methodReference methodSymbol  ! !

!TOMethodSourceBrowser methodsFor: 'commands' stamp: 'dkh 6/3/2011 15:09'!
sendSelectedMessageToSelf: main script: s id: id

	| res |
	res := self object perform: self selectedMethodSelector.
	main currentSpace push: res selecting: #inspect! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 12:52'!
sourceChanged

	^self methodSource ~= self originalSource! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 05/31/2011 12:31'!
sourceChangedUrl
	self errorFlag ifTrue: [ ^TOJQueryLibrary urlOf: #redButtonJpg].
	^ self sourceChanged
		ifTrue: [ TOJQueryLibrary urlOf: #yellowButtonJpg ]
		ifFalse: [ TOJQueryLibrary urlOf: #greenButtonJpg ]! !
